#include <iostream>
#include <fstream>
#include <iterator>
#include <vector>
#include <cstdlib>
#include <cstring>

#include "base64.hpp"


using namespace std;

int main()
{
  const int size = 439;
  char source[size], source2[size];
  vector<char> dest;
  int i;

  // initialize
  for(i=0; i < size; ++i) source[i] = (rand() & 0xFF);

  // convert to base64
  base64::encode((char*)source, source+size, back_inserter(dest));

  // spit out the result
  copy(dest.begin(), dest.end(), ostream_iterator<char>(cout));
  cout << endl;

  // convert back to binary
  base64::decode(dest.begin(), dest.end(), source2);

  // make sure we got the same thing
  if (memcmp(source, source2, size) == 0)
    cout <<"They're the same!" << endl;
    else cout << "They're different!" << endl;


  // encode from memory to a file
  {
    ofstream file("b64.txt");
    base64::encode((char*)source, source+size, ostream_iterator<char>(file));
  }

  // decode from file to file
  {
    ifstream in("b64.txt");
    ofstream out("b64.bin", ios::binary);

    base64::decode(istream_iterator<char>(in), istream_iterator<char>(), 
                   ostream_iterator<char>(out)
                  );
  }
 
  return 0;
}